;  Start of DRAW

vSmallX         equ 100                         ;
vSmallY         equ 160                         ;

vMediumX        equ 240                         ;
vMediumY        equ 320                         ;

vLargeX         equ 400                         ;
vLargeY         equ 500                         ;

ObjectDescs     defw aFixed    ,vSmallX  ,vSmallY  ,Hole
                defw aFixed    ,vMediumX ,vMediumY ,Hole
                defw aFixed    ,vLargeX  ,vLargeY  ,Hole

                defw aVari     ,CycleXY  ,vLargeX  ,Hole
                defw aVari     ,CycleY   ,vLargeX  ,Hole
                defw aVari     ,CycleX   ,vLargeX  ,Hole
                defw aVari1    ,CycleXmY ,vLargeX  ,Hole

                defw aVari     ,OneXY    ,0        ,Hole
                defw aVari     ,OneXY    ,vMediumX ,Hole

                defw aIris     ,CycleXY  ,vLargeX  ,Hole
                defw aIrisA    ,CycleXY  ,vLargeX  ,Hole
                defw aIrisB    ,CycleXY  ,vLargeX  ,Hole
                defw aIrisC    ,CycleXY  ,vLargeX  ,Hole

                defw aIrisC    ,CycleXY  ,vLargeX  ,Hole
                defw aIrisC    ,CycleXY  ,vLargeX  ,Hole
                defw aIrisC    ,CycleXY  ,vLargeX  ,Hole

;  #10

                defw aMiss     ,ChaserA  ,20       ,Miss
                defw aMiss     ,ChaserB  ,vSmallX  ,Miss

                defw aExpl     ,ExplTab1 ,0        ,Miss
                defw aExpl     ,ExplTab2 ,0        ,Miss

                defw Ret0       ,0        ,0        ,Slugs

                defw aSAM      ,20       ,-200     ,SAM
                defw aSAM      ,15       ,-300     ,SAM
                defw aSAM      ,10       ,-400     ,SAM

                defw aSAMa     ,20       ,-200     ,SAM
                defw aSAMa     ,15       ,-300     ,SAM
                defw aSAMa     ,10       ,-400     ,SAM

                defw aSAM      ,40       ,-100     ,SAM

                defw aMine     ,30       ,-200     ,TOW

                defw aBunker   ,20       ,-30      ,TOW
                defw aCodeXmit ,20       ,-100     ,TOW

                defw aSAMSqu   ,20       ,-200     ,SAM

;  #20

                defw aSquTow   ,10       ,-200     ,TOW
                defw aSquTow   ,20       ,-200     ,TOW
                defw aSquTow   ,30       ,-200     ,TOW

                defw aSquMiss  ,ChaserB  ,20       ,Miss

                defw aRising   ,10       ,-200     ,SAM

                defw aFuel     ,CycleXY  ,vLargeX  ,Hole

                defw aWarp     ,CycleXmY ,vLargeX  ,Hole

                defw aCodeXm1  ,20       ,-100     ,TOW


aFuel           ld bc,FuelHit                   ;
                ld (iy+dObjeColl),bc            ;

                jp aVari                        ;

aWarp           ld bc,WarpHit                   ;
                ld (iy+dObjeColl),bc            ;

                ld bc,Ret0                      ;
                ld (iy+dObjeShot),bc            ;

                ld bc,Ret0                      ;
                ld (iy+dObjeMiss),bc            ;

                ld (iy+dObjeWindF),0            ;
                ld (iy+dObjeCol),$46            ;

                ld bc,DispSquareB               ;
                ld (iy+dObjeDraw),bc            ;

                jp aVari1                       ;

aSquTow         ld (iy+dObjeBdYS),de            ;
                ld (iy+dObjeCntA),l             ;

                ret                             ;

aBunker         ld bc,$0300                     ;
                ld (iy+dObjeAXS),bc             ;

                ld bc,$C0                       ;
                ld (iy+dObjeAYS),bc             ;

                jp aSquTow                      ;

aCodeXmit       ld bc,(pMap)                    ;
                ld a,(bc)                       ;

                cp $FB                          ;
                jr nz,aCodeXm1                  ;

                ld bc,CodeSend                  ;
                ld (iy+dObjeColl),bc            ;

aCodeXm1        ld (iy+dObjeCol),$43            ;

                ld bc,DispDiamond               ;
                ld (iy+dObjeDraw),bc            ;

                ld (iy+dObjeClipFlags),0        ;

                jp aSquTow                      ;

aMine           ld bc,DispMiss                  ;
                ld (iy+dObjeDraw),bc            ;

                jp aSquTow                      ;

aRising         set 0,(iy+dObjeStateF)          ;

aSAMSqu         ld a,tSquMiss                   ;
                ld (iy+dObjeWeapon),a           ;

                jr aSAM                         ;

aSAMa           ld a,tMiss                      ;
                ld (iy+dObjeWeapon),a           ;

aSAM            ld (iy+dObjeBdYS),de            ;
                ld (iy+dObjeCntA),l             ;
                ld (iy+dObjeCntiA),l            ;

                ld bc,(GroundY)                 ;
                ld (iy+dObjeY),bc               ;

                ret                             ;

aFixed          ld (iy+dObjeBXS),hl             ;
                ld (iy+dObjeBYS),de             ;

                ret                             ;

aVari           ld (iy+dObjepSizeTab),hl        ;

                ld (iy+dObjeBXS),de             ;
                ld (iy+dObjeBYS),de             ;
                ret                             ;

aVari1          ld (iy+dObjepSizeTab),hl        ;

                ld (iy+dObjeBYS),de             ;

                ld de,0                         ;
                ld (iy+dObjeBXS),de             ;

                ret                             ;

aIris           ld bc,DispIris                  ;

aIrisCommon     ld (iy+dObjeDraw),bc            ;

                ld bc,vLargeX                   ;
                ld (iy+dObjeAXS),bc             ;
                ld (iy+dObjeAYS),bc             ;

                jp aVari                        ;

aIrisA          ld bc,DispIrisA                 ;
                jp aIrisCommon                  ;

aIrisB          ld bc,DispIrisB                 ;
                jp aIrisCommon                  ;

aIrisC          ld bc,DispIrisC                 ;
                jp aIrisCommon                  ;

aSquMiss        ld bc,DispSquMiss               ;
                ld (iy+dObjeDraw),bc            ;

aMiss           ld (iy+dObjeMove),hl            ;
                ld (iy+dObjeCntiA),e            ;
                ld hl,PlayerShot                ;
                ld (iy+dObjeColl),hl            ;

                set bScreenClip,(iy+dObjeFlags) ;
                res bCursorClip,(iy+dObjeFlags) ;

                ret                             ;

aProj           ld (iy+dObjeAXS),hl             ;
                ld (iy+dObjeCntA),e             ;

                set bRepeat,(iy+dObjeFlags)     ;

                ld (iy+dObjepUnDraw),-2         ;

aExpl           ld bc,ExplTab1                  ;
                ld (iy+dObjepSizeTab),bc        ;

                ld bc,Ret0                      ;
                ld (iy+dObjeColl),bc            ;
                ld (iy+dObjeShot),bc            ;
                ld (iy+dObjeMiss),bc            ;
                ld (iy+dObjeAlter),bc           ;
                ld (iy+dObjeMove),bc            ;

                ld bc,DispExpl                  ;
                ld (iy+dObjeDraw),bc            ;

                ld (iy+dObjeClipFlags),0        ;

                ret                             ;

CycleXY         defb 30                         ;
                defw -13,-13                    ;

                defb 30                         ;
                defw 13,13                      ;

                defb 0                          ;
                defw CycleXY                    ;

CycleX          defb 30                         ;
                defw -13,0                      ;

                defb 30                         ;
                defw 13,0                       ;

                defb 0                          ;
                defw CycleX                     ;

CycleY          defb 30                         ;
                defw 0,-13                      ;

                defb 30                         ;
                defw 0,13                       ;

                defb 0                          ;
                defw CycleY                     ;

CycleXmY        defb 30                         ;
                defw 13,-13                     ;

                defb 30                         ;
                defw -13,13                     ;

                defb 0                          ;
                defw CycleXmY                   ;

OneXY           defb 30                         ;
                defw 13,13                      ;

                defb 30                         ;
                defw -13,-13                    ;

                defb 0                          ;
                defw FixedSize                  ;

ExplTab1        defb $1E,$0F,$04                ;
                defb $23,$16,$04                ;
                defb $28,$1E,$05                ;
                defb $2D,$25,$05                ;
                defb $32,$2D,$06                ;
                defb $37,$34,$06                ;
                defb $3C,$3C,$07                ;
                defb $41,$43,$07                ;
                defb $46,$4B,$06                ;
                defb $4B,$52,$05                ;
                defb $50,$5A,$04                ;
                defb $55,$61,$03                ;
                defb $5A,$69,$02                ;
                defb $5F,$70,$01                ;
                defb $00,$00,$00                ;

ExplTab2        defb $3C,$0F,$04                ;
                defb $46,$16,$04                ;
                defb $50,$1E,$05                ;
                defb $5A,$25,$05                ;
                defb $64,$2D,$06                ;
                defb $6E,$34,$06                ;
                defb $78,$3C,$07                ;
                defb $82,$43,$07                ;
                defb $8C,$4B,$06                ;
                defb $96,$52,$05                ;
                defb $A0,$5A,$04                ;
                defb $AA,$61,$03                ;
                defb $B4,$69,$02                ;
                defb $BE,$70,$01                ;
                defb $00,$00,$00                ;

ProjTab         defb $14,$0F,$44                ;
                defb $28,$1E,$45                ;
                defb $3C,$2D,$46                ;
                defb $55,$3C,$47                ;
                defb $55,$3C,$47                ;
                defb $3C,$2D,$46                ;
                defb $28,$1E,$45                ;
                defb $14,$0F,$44                ;
                defb $00,$00,$00                ;

; Oops - I was playing about with macros here and I really didn't intend this mess to slip into the live source. Sorry...

PlantObje       macro(p1,p2,p3,p4,p5,p6,p7,p8,p9,p10,p11,p12,p13,p14,p15,p16,p17,p18,p19,p20,p21,p22,p23,p24,p25,p26,p27,p28)

                defb p1                         ;
                defw p2                         ; Draw
                defw p3                         ; Shot
                defw p4                         ; Coll
                defw p5                         ; Miss
                defw p6                         ; Alter
                defw p7                         ; Move

                defb p8                         ; Flags
                defb p9                         ; StateF
                defb p10                        ; StarComp

                defw p11                        ; AXS
                defw p12                        ; AYS

                defw p13                        ; SizeTab
                defb p14                        ; Cnt
                defw p15                        ; BdXS
                defw p16                        ; BdYS
                defw p17                        ; BXS
                defw p18                        ; BYS

                defb p19                        ; WindF

                defb p20                        ; Col

                defb p21                        ; CntA
                defb p22                        ; CntiA
                defb p23                        ; CntB
                defb p24                        ; CntiB

                defb p25                        ; WidthX
                defb p26                        ; WidthY
                defb p27                        ; ClipFlags

                defb p28                        ; Weapon
        mend

Hole            PlantObje(-1,DispForce             ,Ret0     ,HoleHit,HoleMissed,DoSizeCycle,Ret0,bbCursorClip,0,0,0,0,FixedSize,1,0,0,vMediumX,vMediumY,bbSetWind,$45,0,0,0,0,0,0,0,0)
HoleEnd         equ $                           ; Length of a definition

Miss            PlantObje(-3,DispSlugs   ,MissShot ,Ret0     ,Ret0   ,Ret0      ,Ret0       ,0,0,3,$100,$100,0,1,0,0,0,0,0,$45,1,20,0,0,2,2,bbClipCent,0)
SAM             PlantObje(-1,DispSAM     ,Ret0     ,Ret0     ,Ret0   ,Ret0      ,Ret0       ,0,0,3,0,0,0,1,0,-140,0,0,0,$45,40,40,2,0,2,2,bbClipBelow,tMissA)
TOW             PlantObje(-1,DispSquTower,TowerShot,TowerColl,Ret0   ,Ret0      ,MoveTower  ,bbScreenClip,0,3,$80,$100,0,1,MoveTower,0,0,0,0,$45,40,40,2,0,2,2,bbClipBelow,tMissA)
Slugs           PlantObje(-3,DispSlugs   ,Ret0     ,Ret0     ,Ret0   ,Ret0      ,TestHit    ,0,0,0,0,0,0,28,200,0,0,0,bSlug,$45,40,1,0,0,0,0,0,0)

MoveTower       ld a,(ix+dObjeStateF)           ;
                cp 1                            ;
                jr z,TowerFire                  ;

                dec (ix+dObjeCntA)              ;
                jr z,MTa                        ;

                ld hl,(ix+dObjeY)               ;
                ld de,(ix+dObjeBdYS)            ;

                add hl,de                       ;

                cp 2                            ;
                jr nz,MT0                       ;

                or a                            ;
                sbc hl,de                       ;
                or a                            ;
                sbc hl,de                       ;

MT0             ld (ix+dObjeY),hl               ;

                ex de,hl                        ;
                ld hl,(GroundY)                 ;

                or a                            ;
                sbc hl,de                       ;
                ret p                           ;

                jp KillObject                   ;

MTa             ld (ix+dObjeStateF),$01         ;
                ret                             ;

TowerFire       ld a,r                          ;
                and $3F                         ;
                ret nz                          ;

                bit 7,(ix+dObjeY+1)             ;
                ret nz                          ;

                jp FireMissile                  ;

DispDiamond     ld hl,(ix+dObjeX)               ;

                ld de,(ix+dObjeZ)               ;
                ld (TempZ),de                   ;

                call ObjeDiv                    ;

                ld (X1),hl                      ;

                ld hl,(ix+dObjeY)               ;

                ld de,(TempZ)                   ;

                call ObjeDiv                    ;

                ld (Y1),hl                      ;

                ld hl,(X1)                      ;

                ld de,-128                      ;
                or a                            ;
                sbc hl,de                       ;
                jp m,KillObject                 ;

                ld de,255                       ;
                or a                            ;
                sbc hl,de                       ;
                jp p,KillObject                 ;

                set bOnScreen,(ix+dObjeFlags)   ;

                ld hl,300                       ;

                ld de,(TempZ)                   ;

                call ObjeDiv                    ;

                ex de,hl                        ;

                ld hl,(X1)                      ;
                add hl,de                       ;
                ld (X2),hl                      ;
                add hl,de                       ;
                ld (X3),hl                      ;

                ld hl,(X1)                      ;
                or a                            ;
                sbc hl,de                       ;
                ld (X4),hl                      ;
                or a                            ;
                sbc hl,de                       ;
                ld (X5),hl                      ;

                ld hl,(Y1)                      ;
                add hl,de                       ;
                ld (Y2),hl                      ;
                add hl,de                       ;
                ld (Y3),hl                      ;
                add hl,de                       ;
                ld (Y3a),hl                     ;

                ld hl,(Y1)                      ;
                or a                            ;
                sbc hl,de                       ;
                ld (Y4),hl                      ;
                or a                            ;
                sbc hl,de                       ;
                ld (Y5),hl                      ;
                or a                            ;
                sbc hl,de                       ;
                ld (Y5a),hl                     ;

                call UndrawLines                ;

                call AddFirstLine               ;
                ret c                           ;

                ld hl,(Y4)                      ;
                ld de,(Y2)                      ;
                ld bc,(X5)                      ;

                call VertLine                   ;

                call c,AddLine                  ;

                ld hl,(Y4)                      ;
                ld de,(Y2)                      ;
                ld bc,(X3)                      ;

                call VertLine                   ;

                call c,AddLine                  ;

                ld hl,(Y5)                      ;
                ld de,(Y3)                      ;
                ld bc,(X4)                      ;

                call VertLine                   ;

                call c,AddLine                  ;

                ld hl,$0000                     ;
Y5a             equ .-2                         ;
                ld de,$0000                     ;
Y3a             equ .-2                         ;
                ld bc,(X1)                      ;

                call VertLine                   ;

                call c,AddLine                  ;

                ld hl,(Y5)                      ;
                ld de,(Y3)                      ;
                ld bc,(X2)                      ;

                jp VertLine                     ;

CodeSend        ld a,$10                        ;
                call AddScore                   ;

                jp AddCodes                     ;

DispSquMiss     call DispSquare                 ;
                bit 0,(ix+dObjeFlags)           ;
                ret nz                          ;

                jp KillObject                   ;

DispSquTower    ld hl,(ix+dObjeX)               ;
                ld (TempX),hl                   ;

                ld de,(ix+dObjeZ)               ;
                ld (TempZ),de                   ;

                ld bc,(ix+dObjeAXS)             ;
                or a                            ;
                sbc hl,bc                       ;

                ld (TempX1),hl                  ;

                push bc                         ;
                call ObjeDiv                    ;
                pop bc                          ;

                ld (X1),hl                      ;

                ld hl,(TempX)                   ;
                add hl,bc                       ;
                ld (TempXr),hl                  ;

                call ObjeDiv                    ;

                ld (X2),hl                      ;

                ld de,(X1)                      ;
                or a                            ;
                sbc hl,de                       ;

                ret m                           ;

                add hl,de                       ;
                ld bc,-128                      ;
                or a                            ;
                sbc hl,bc                       ;
                jp m,KillObject                 ;

                ld de,255                       ;
                or a                            ;
                sbc hl,de                       ;
                jp p,KillObject                 ;

                ld hl,(ix+dObjeY)               ;
                ld (TempY),hl                   ;
                ld de,(TempZ)                   ;

                call ObjeDiv                    ;

                ld (Y1),hl                      ;

                ld hl,(GroundY)                 ;
                ld de,(TempZ)                   ;

                call ObjeDiv                    ;

                ld (Y2),hl                      ;

                ld hl,(TempZ)                   ;
                ld bc,(ix+dObjeAYS)             ;

                add hl,bc                       ;

                ld (TempZ),hl                   ;

                ex de,hl                        ;

                ld hl,$0000                     ;
TempX1          equ .-2                         ;

                call ObjeDiv                    ;

                ld (X3),hl                      ;

                ld hl,$0000                     ;
TempXr          equ .-2                         ;

                ld de,(TempZ)                   ;

                call ObjeDiv                    ;

                ld (X4),hl                      ;

                ld hl,(TempY)                   ;
                ld de,(TempZ)                   ;

                call ObjeDiv                    ;

                ld (Y3),hl                      ;

                ld hl,(GroundY)                 ;
                ld de,(TempZ)                   ;

                call ObjeDiv                    ;

                ld (Y4),hl                      ;

                call UndrawLines                ;

                call AddFirstLine               ;
                ret c                           ;

                ld hl,(X4)                      ;

                ld bc,(X2)                      ;

                dec bc                          ;
                dec hl                          ;
                or a                            ;
                sbc hl,bc                       ;

                jp p,Towerad                    ;

                ld hl,(X1)                      ;
                ld bc,(X3)                      ;

                dec hl                          ;
                or a                            ;
                sbc hl,bc                       ;
                jp p,Towercf                    ;

Towerbe         ld a,(Y1+1)                     ;
                bit 7,a                         ;
                jr nz,Towere                    ;

                ld de,(Y2)                      ;
                ld hl,(Y1)                      ;
                ld bc,(X1)                      ;

                call VertLine                   ;

                call c,AddLine                  ;

                ld de,(Y2)                      ;
                ld hl,(Y1)                      ;
                ld bc,(X2)                      ;

                call VertLine                   ;

                call c,AddLine                  ;

                ld hl,(X1)                      ;
                ld de,(X2)                      ;
                ld bc,(Y1)                      ;

                call HoriLine                   ;

                call c,AddLine                  ;

                ld hl,(X3)                      ;
                ld de,(X4)                      ;
                ld bc,(Y3)                      ;

                call HoriLine                   ;

                call c,AddLine                  ;

                ld hl,(X3)                      ;
                ld de,(X1)                      ;
                exx                             ;
                ld hl,(Y3)                      ;
                ld de,(Y1)                      ;
                exx                             ;

                call AnyLine                    ;

                call c,AddLine                  ;

                ld hl,(X4)                      ;
                ld de,(X2)                      ;
                exx                             ;
                ld hl,(Y3)                      ;
                ld de,(Y1)                      ;
                exx                             ;

                jp AnyLine                      ;

Towere          ld hl,(Y1)                      ;
                ld de,(Y2)                      ;
                ld bc,(X1)                      ;

                call VertLine                   ;

                call c,AddLine                  ;

                ld hl,(Y1)                      ;
                ld de,(Y2)                      ;
                ld bc,(X2)                      ;

                call VertLine                   ;

                call c,AddLine                  ;

                ld hl,(X1)                      ;
                ld de,(X2)                      ;
                ld bc,(Y1)                      ;

                jp HoriLine                     ;

Towerad         ld a,(Y1+1)                     ;
                bit 7,a                         ;
                jr nz,Towerd                    ;

                ld hl,(Y1)                      ;
                ld de,(Y2)                      ;
                ld bc,(X1)                      ;

                call VertLine                   ;

                call c,AddLine                  ;

                ld hl,(Y1)                      ;
                ld de,(Y2)                      ;
                ld bc,(X2)                      ;

                call VertLine                   ;

                call c,AddLine                  ;

                ld hl,(Y3)                      ;
                ld de,(Y4)                      ;
                ld bc,(X4)                      ;

                call VertLine                   ;

                call c,AddLine                  ;

                ld hl,(X1)                      ;
                ld de,(X2)                      ;
                ld bc,(Y1)                      ;

                call HoriLine                   ;

                call c,AddLine                  ;

                ld hl,(X3)                      ;
                ld de,(X4)                      ;
                ld bc,(Y3)                      ;

                call HoriLine                   ;

                call c,AddLine                  ;

                ld hl,(X3)                      ;
                ld de,(X1)                      ;
                exx                             ;
                ld hl,(Y3)                      ;
                ld de,(Y1)                      ;
                exx                             ;

                call AnyLine                    ;

                call c,AddLine                  ;

                ld hl,(X4)                      ;
                ld de,(X2)                      ;
                exx                             ;
                ld hl,(Y3)                      ;
                ld de,(Y1)                      ;
                exx                             ;

                jp AnyLine                      ;

Towerd          ld hl,(Y1)                      ;
                ld de,(Y2)                      ;
                ld bc,(X1)                      ;

                call VertLine                   ;

                call c,AddLine                  ;

                ld hl,(Y1)                      ;
                ld de,(Y2)                      ;
                ld bc,(X2)                      ;

                call VertLine                   ;

                call c,AddLine                  ;

                ld hl,(Y3)                      ;
                ld de,(Y4)                      ;
                ld bc,(X4)                      ;

                call VertLine                   ;

                call c,AddLine                  ;

                ld hl,(X1)                      ;
                ld de,(X2)                      ;
                ld bc,(Y1)                      ;

                call HoriLine                   ;

                call c,AddLine                  ;

                ld hl,(X4)                      ;
                ld de,(X2)                      ;
                exx                             ;
                ld hl,(Y3)                      ;
                ld de,(Y1)                      ;
                exx                             ;

                jp AnyLine                      ;

Towercf         ld a,(Y1+1)                     ;
                bit 7,a                         ;
                jr nz,Towerf                    ;

                ld hl,(Y1)                      ;
                ld de,(Y2)                      ;
                ld bc,(X1)                      ;

                call VertLine                   ;

                call c,AddLine                  ;

                ld hl,(Y1)                      ;
                ld de,(Y2)                      ;
                ld bc,(X2)                      ;

                call VertLine                   ;

                call c,AddLine                  ;

                ld hl,(Y3)                      ;
                ld de,(Y4)                      ;
                ld bc,(X3)                      ;

                call VertLine                   ;

                call c,AddLine                  ;

                ld hl,(X1)                      ;
                ld de,(X2)                      ;
                ld bc,(Y1)                      ;

                call HoriLine                   ;

                call c,AddLine                  ;

                ld hl,(X3)                      ;
                ld de,(X4)                      ;
                ld bc,(Y3)                      ;

                call HoriLine                   ;

                call c,AddLine                  ;

                ld hl,(X3)                      ;
                ld de,(X1)                      ;
                exx                             ;
                ld hl,(Y3)                      ;
                ld de,(Y1)                      ;
                exx                             ;

                call AnyLine                    ;

                call c,AddLine                  ;

                ld hl,(X4)                      ;
                ld de,(X2)                      ;
                exx                             ;
                ld hl,(Y3)                      ;
                ld de,(Y1)                      ;
                exx                             ;

                jp AnyLine                      ;

Towerf          ld hl,(Y1)                      ;
                ld de,(Y2)                      ;
                ld bc,(X1)                      ;

                call VertLine                   ;

                call c,AddLine                  ;

                ld hl,(Y1)                      ;
                ld de,(Y2)                      ;
                ld bc,(X2)                      ;

                call VertLine                   ;

                call c,AddLine                  ;

                ld hl,(Y3)                      ;
                ld de,(Y4)                      ;
                ld bc,(X3)                      ;

                call VertLine                   ;

                call c,AddLine                  ;

                ld hl,(X1)                      ;
                ld de,(X2)                      ;
                ld bc,(Y1)                      ;

                call HoriLine                   ;

                call c,AddLine                  ;

                ld hl,(X3)                      ;
                ld de,(X1)                      ;
                exx                             ;
                ld hl,(Y3)                      ;
                ld de,(Y1)                      ;
                exx                             ;

                jp AnyLine                      ;

TestHit         push ix                         ;

                ld a,(ix+dObjeOX+1)             ;
                add a,(ix+dObjeX+1)             ;
                rra                             ;
                ld d,a                          ;

                ld a,(ix+dObjeOY+1)             ;
                add a,(ix+dObjeY+1)             ;
                rra                             ;
                ld e,a                          ;

                exx                             ;

                ld de,(ix+dObjeOZ)              ;
                ld b,0                          ;

TestH1p         ld (THtempIX),ix                ;

                ld hl,(ix+dppObje)              ;
                ld a,h                          ;
                or l                            ;
                jr z,TestH1                     ;

                inc b                           ;

                push hl                         ;
                pop ix                          ;

                ld hl,(ix+dObjeOZ)              ;
                or a                            ;
                sbc hl,de                       ;

                jr nc,TestH1p                   ;

                ld ix,$0000                     ;
THtempIX        equ .-2                         ;

                dec b                           ;

                jp TestH2                       ;

TestH1          ld ix,(pObjeList)               ;

TestH2          ld a,b                          ;
                or a                            ;
                jr z,TestH4                     ;

                exx                             ;

                ld b,a                          ;

TestH3          ld a,(ix+dObjeClipFlags)        ;
                or a                            ;
                jr z,TestH3a                    ;

                ld a,(ix+dObjeOX+1)             ;
                add a,(ix+dObjeX+1)             ;
                rra                             ;

                sub d                           ;

                jp p,AbsX                       ;

                neg                             ;

AbsX            cp (ix+dObjeWidthX)             ;
                jr nc,TestH3a                   ;

                ld a,(ix+dObjeOY+1)             ;
                add a,(ix+dObjeY+1)             ;
                rra                             ;

                bit bClipCent,(ix+dObjeClipFlags);
                jr nz,TestCC                    ;

                cp e                            ;
                jp p,TestH3a                    ;

                jp TestTrue                     ;

TestCC          sub e                           ;

                jp p,AbsY                       ;

                neg                             ;

AbsY            cp (ix+dObjeWidthY)             ;
                jr nc,TestH3a                   ;

TestTrue        ld hl,(ix+dObjeShot)            ;
                call CallHL                     ;

                push ix                         ;
                pop hl                          ;

                pop ix                          ;

                push iy                         ;

                push ix                         ;
                pop iy                          ;

                call aExpl                      ;

                push iy                         ;
                pop de                          ;

                pop iy                          ;

                ld bc,$000C                     ;
                add hl,bc                       ;

                ex de,hl                        ;
                add hl,bc                       ;
                ex de,hl                        ;

                ld bc,3*2                       ;
                ldir                            ;

                ret                             ;

TestH3a         ld hl,(ix+dpnObje)              ;
                push hl                         ;
                pop ix                          ;

                djnz TestH3                     ;

TestH4          pop ix                          ;
                ret                             ;

PlayerShot      ld a,(AType)                    ;
                ld b,a                          ;
                jp DoDamage                     ;

WarpHit         ld de,(pMap)                    ;

                ld iy,Tunnels                   ;

                ld bc,6                         ;

                ld a,12                         ;

FindTunnel      ld hl,(iy+dTunnelPos1)          ;
                or a                            ;
                sbc hl,de                       ;
                jr z,WH1                        ;

                ld hl,(iy+dTunnelPos2)          ;
                or a                            ;
                sbc hl,de                       ;
                jr z,WH2                        ;

                add iy,bc                       ;

                dec a                           ;
                jr nz,FindTunnel                ;

                ld hl,$6021                     ;
                ld a,3                          ;
                jr WH3                          ;

WH1             ld hl,(iy+dTunnelPos2)          ;
                ld a,(iy+dTunnelAngle2)         ;

                jr WH3                          ;

WH2             ld hl,(iy+dTunnelPos1)          ;
                ld a,(iy+dTunnelAngle1)         ;

WH3             ld (pMap),hl                    ;
                ld (Angle),a                    ;

                ld hl,(ArrowPos)                ;

                jp Print8x8                     ;

Tunnels         defw $6012                      ;
                defb $02                        ;
                defw $61FD                      ;
                defb $00                        ;

                defw $6106                      ;
                defb $00                        ;
                defw $61B2                      ;
                defb $06                        ;

                defw $6146                      ;
                defb $07                        ;
                defw $61C7                      ;
                defb $01                        ;

                defw $6063                      ;
                defb $02                        ;
                defw $6067                      ;
                defb $02                        ;

                defw $6098                      ;
                defb $02                        ;
                defw $617F                      ;
                defb $04                        ;

                defw $6095                      ;
                defb $02                        ;
                defw $615F                      ;
                defb $04                        ;

                defw $60F8                      ;
                defb $02                        ;
                defw $613F                      ;
                defb $04                        ;

                defw $605C                      ;
                defb $02                        ;
                defw $60D8                      ;
                defb $02                        ;

                defw $606E                      ;
                defb $01                        ;
                defw $60A5                      ;
                defb $05                        ;

                defw $616A                      ;
                defb $00                        ;
                defw $61E9                      ;
                defb $06                        ;

                defw $61B4                      ;
                defb $06                        ;
                defw $61CC                      ;
                defb $05                        ;

                defw $6076                      ;
                defb $04                        ;
                defw $61AE                      ;
                defb $04                        ;

HoleHit         bit bFake,(ix+dObjeStateF)      ;
                ret nz                          ;

                ld a,HoleScore                  ;
                jp AddScore                     ;

FuelHit         bit bFake,(ix+dObjeStateF)      ;
                ret nz                          ;

                ld b,FuelDam                    ;
                jp AlwaysDoDamage               ;

MissShot        ld a,MissScore                  ;
                call AddScore                   ;

                set bKilled,(ix+dObjeFlags)     ;
                ret                             ;

TowerShot       ld a,TowerScore                 ;
                call AddScore                   ;

                ld (ix+dObjeStateF),2           ;

                ld hl,(ix+dObjeBdYS)            ;
                ld de,-20                       ;
                add hl,de                       ;
                ld (ix+dObjeBdYS),hl            ;

                ret                             ;

TowerColl       ld b,TowerDam                   ;
                call AlwaysDoDamage             ;

                ld a,TowerScore                 ;
                jp SubScore                     ;

HoleMissed      bit bFake,(ix+dObjeStateF)      ;
                ret nz                          ;

                ld a,(AType)                    ;
                ld b,a                          ;

                jp AlwaysDoDamage               ;

FixedSize       defb 255                        ;
                defw 0,0                        ;

                defb 0                          ;
                defw FixedSize                  ;

CreateObject    ld (TempAcc1),a                 ;
                and $3F                         ;
                ld (TempAcc),a                  ;

                push de                         ;
                push bc                         ;

                call AddObje                    ;

                pop bc                          ;
                pop de                          ;

                ret c                           ;

                call COinn                      ;

                ld a,0                          ;
TempAcc1        equ .-1                         ;

                and $C0                         ;
                or (iy+dObjeStateF)             ;
                ld (iy+dObjeStateF),a           ;

                ld a,(iy+dObjeStarComp)         ;
                neg                             ;
                jp LimitStarCnt                 ;

COinn           ld (iy+dObjeX),de               ;
                ld (iy+dObjeY),bc               ;

                exx                             ;

                ld (iy+dObjedZ),hl              ;
                ld (iy+dObjedX),de              ;
                ld (iy+dObjedY),bc              ;

                exx                             ;

                ld d,iyh                        ;
                ld e,iyl                        ;
                ld hl,dObjepLines               ;
                add hl,de                       ;

                ld b,8                          ;
                xor a                           ;

COlp            ld (hl),a                       ;
                inc hl                          ;
                ld (hl),a                       ;
                inc hl                          ;

                djnz COlp                       ;

                ld (hl),a                       ;
                inc hl                          ;

                ex de,hl                        ;

                ld l,0                          ;
TempAcc         equ .-1                         ;
                ld h,0                          ;

                add hl,hl                       ;
                add hl,hl                       ;
                add hl,hl                       ;

                ld bc,ObjectDescs               ;
                add hl,bc                       ;

                ld c,(hl)                       ;
                inc hl                          ;
                ld b,(hl)                       ;
                inc hl                          ;
                push bc                         ;

                ld c,(hl)                       ;
                inc hl                          ;
                ld b,(hl)                       ;
                inc hl                          ;
                push bc                         ;

                ld c,(hl)                       ;
                inc hl                          ;
                ld b,(hl)                       ;
                inc hl                          ;
                push bc                         ;

                ld a,(hl)                       ;
                inc hl                          ;
                ld h,(hl)                       ;
                ld l,a                          ;

                ld bc,HoleEnd-Hole              ;

                ldir                            ;

                pop de                          ;
                pop hl                          ;
                ret                             ;

CalcSquareA12   ld hl,(ix+dObjeAXS)             ;
                ld de,(ix+dObjeAYS)             ;

                ld iy,X1                        ;

                jp CalcSquare                   ;

CalcSquareB12   ld hl,(ix+dObjeBXS)             ;
                ld de,(ix+dObjeBYS)             ;

                ld iy,X1                        ;

                jp CalcSquare                   ;

CalcSquareA34   ld hl,(ix+dObjeAXS)             ;
                ld de,(ix+dObjeAYS)             ;

                ld iy,X3                        ;

                jp CalcSquare                   ;

CalcSquareB34   ld hl,(ix+dObjeBXS)             ;
                ld de,(ix+dObjeBYS)             ;

                ld iy,X3                        ;

                jp CalcSquare                   ;

CalcSquare      push de                         ;
                push hl                         ;

                ld bc,(ix+dObjeX)               ;

                add hl,bc                       ;

                ld de,(ix+dObjeZ)               ;

                push de                         ;
                push bc                         ;
                call ObjeDiv                    ;
                pop bc                          ;
                pop de                          ;

                ld (iy),l                       ;
                ld (iy+1),h                     ;

                pop hl                          ;

                Neg_HL()                        ;

                add hl,bc                       ;

                push de                         ;
                call ObjeDiv                    ;
                pop de                          ;

                ld (iy+2),l                     ;
                ld (iy+3),h                     ;

                pop hl                          ;
                push hl                         ;

                ld bc,(ix+dObjeY)               ;

                add hl,bc                       ;

                ld de,(ix+dObjeZ)               ;

                push de                         ;
                push bc                         ;
                call ObjeDiv                    ;
                pop bc                          ;
                pop de                          ;

                ld (iy+4),l                     ;
                ld (iy+5),h                     ;

                pop hl                          ;

                Neg_HL()                        ;

                add hl,bc                       ;

                push de                         ;
                call ObjeDiv                    ;
                pop de                          ;

                ld (iy+6),l                     ;
                ld (iy+7),h                     ;

                ret                             ;

ChaserA         dec (ix+dObjeCntA)              ;
                ret nz                          ;

                ld a,(ix+dObjeCntiA)            ;
                ld (ix+dObjeCntA),a             ;

                ld b,40                         ;
                ld c,57                         ;
                ld a,r                          ;
                and $31                         ;
                jp nz,OFAim                     ;

                ld (ix+dObjeCntiA),100          ;

                ld hl,ChaserB                   ;
                ld (ix+dObjeMove),hl            ;

ChaserB         dec (ix+dObjeCntA)              ;
                ret nz                          ;

                ld a,(ix+dObjeCntiA)            ;
                ld (ix+dObjeCntA),a             ;

                ld b,17                         ;
                ld c,20                         ;

                jp OFAim                        ;

OFAim           exx                             ;

                ld hl,(DeltaX)                  ;

                Neg_HL()                        ;
                call MissAimMult                ;

                ld de,(ix+dObjeX)               ;
                or a                            ;
                sbc hl,de                       ;

                call MissAimDiv                 ;

                ld (ix+dObjedX),hl              ;

                ld hl,(DeltaY)                  ;

                Neg_HL()                        ;
                call MissAimMult                ;

                ld de,(ix+dObjeY)               ;
                or a                            ;
                sbc hl,de                       ;

                call MissAimDiv                 ;

                ld (ix+dObjedY),hl              ;

                ld hl,(DeltaZ)                  ;

                Neg_HL()                        ;
                call MissAimMult                ;

                ld de,(ix+dObjeZ)               ;
                or a                            ;
                sbc hl,de                       ;

                call MissAimDiv                 ;

                ld (ix+dObjedZ),hl              ;

                ret                             ;

MissAimMult     exx                             ;
                ld a,c                          ;
                exx                             ;

                ld e,0                          ;
                ld d,a                          ;

                jp SignMult                     ;

MissAimDiv      exx                             ;
                ld a,b                          ;
                exx                             ;

                ld e,0                          ;
                ld d,a                          ;

                jp SignDiv                      ;

                dec (ix+dObjeCntA)              ;
                jr nz,DispExpl                  ;

KillObject      set bKilled,(ix+dObjeFlags)     ;
                ret                             ;

DispSlugs       dec (ix+dObjeCnt)               ;
                jp z,KillObject                 ;

                ld hl,(ix+dObjeY)               ;

                ld de,(GroundY)                 ;
                or a                            ;
                sbc hl,de                       ;

                jp p,KillObject                 ;

                add hl,de                       ;

                ld de,(ix+dObjeZ)               ;
                ld (TempZ),de                   ;

                call ObjeDiv                    ;

                ld (Y1),hl                      ;

                ld hl,(ix+dObjeX)               ;
                ld bc,(ix+dObjeBdXS)            ;
                add hl,bc                       ;

                ld de,(TempZ)                   ;

                call ObjeDiv                    ;

                ld (X2),hl                      ;

                ld hl,(ix+dObjeX)               ;
                ld bc,(ix+dObjeBdXS)            ;
                or a                            ;
                sbc hl,bc                       ;

                ld de,(TempZ)                   ;

                call ObjeDiv                    ;

                ld (X1),hl                      ;

                call UndrawLines                ;

                call AddFirstLine               ;
                ret c                           ;

                ld hl,(X1)                      ;
                ld de,(X2)                      ;
                ld bc,(Y1)                      ;

                call HoriLineEx                 ;

                bit bOnScreen,(ix+dObjeFlags)   ;
                ret nz                          ;

                jp KillObject                   ;

DispExpl        ld hl,(ix+dObjeX)               ;
                ld de,(ix+dObjeZ)               ;
                ld (TempZ),de                   ;

                call ObjeDiv                    ;

                ld (X1),hl                      ;

                ld bc,128                       ;
                add hl,bc                       ;
                ld a,h                          ;
                add a,2                         ;
                cp 4                            ;
                jp nc,KillObject                ;

                ld hl,(ix+dObjeY)               ;
                ld de,(TempZ)                   ;

                call ObjeDiv                    ;

                ld (Y1),hl                      ;

                ld bc,128                       ;
                add hl,bc                       ;

                ld a,h                          ;
                add a,2                         ;
                cp 4                            ;
                jp nc,KillObject                ;

                ld hl,(ix+dObjepSizeTab)        ;

                push hl                         ;
                pop iy                          ;

                ld hl,(TempZ)                   ;
                sra h                           ;
                rr l                            ;
                sra h                           ;
                rr l                            ;
                sra h                           ;
                rr l                            ;
                ld (TempZ),hl                   ;

                ld l,(iy)                       ;
                ld a,l                          ;
                or a                            ;
                jr nz,Expl1                     ;

                bit bRepeat,(ix+dObjeFlags)     ;
                jp z,KillObject                 ;

                ld hl,(ix+dObjeAXS)             ;
                push hl                         ;
                pop iy                          ;

                ld l,(iy)                       ;
Expl1           ld h,0                          ;
                inc iy                          ;

                ld de,(TempZ)                   ;

                call ObjeDiv                    ;
                ex de,hl                        ;

                ld hl,(X1)                      ;
                ld b,h                          ;
                ld c,l                          ;

                add hl,de                       ;
                ld (eX1),hl                     ;

                ld h,b                          ;
                ld l,c                          ;
                or a                            ;
                sbc hl,de                       ;

                ld (eX2),hl                     ;

                sra d                           ;
                rr e                            ;

                ld h,b                          ;
                ld l,c                          ;
                add hl,de                       ;

                ld (eX3),hl                     ;

                ld h,b                          ;
                ld l,c                          ;
                or a                            ;
                sbc hl,de                       ;

                ld (eX4),hl                     ;

                ld l,(iy)                       ;
                ld h,0                          ;

                inc iy                          ;

                ld de,(TempZ)                   ;

                call ObjeDiv                    ;
                ex de,hl                        ;

                ld hl,(Y1)                      ;
                ld b,h                          ;
                ld c,l                          ;
                add hl,de                       ;
                ld (eY1),hl                     ;

                ld h,b                          ;
                ld l,c                          ;
                or a                            ;
                sbc hl,de                       ;
                ld (eY2),hl                     ;

                sra d                           ;
                rr e                            ;

                ld h,b                          ;
                ld l,c                          ;
                add hl,de                       ;
                ld (eY3),hl                     ;

                ld h,b                          ;
                ld l,c                          ;
                or a                            ;
                sbc hl,de                       ;
                ld (eY4),hl                     ;

                ld a,(iy)                       ;
                ld (Colour),a                   ;

                inc iy                          ;

                push iy                         ;
                pop hl                          ;

                ld (ix+dObjepSizeTab),hl        ;

                call UndrawLines                ;

                call AddFirstLine               ;
                ret c                           ;

                ld hl,(eX3)                     ;
                ld de,(eX1)                     ;
                ld bc,(eY4)                     ;

                call HoriLineEx                 ;

                call c,AddLine                  ;

                ld de,$0000                     ;
eX1             equ .-2                         ;
                ld hl,$0000                     ;
eX3             equ .-2                         ;
                ld bc,(eY3)                     ;

                call HoriLineEx                 ;

                call c,AddLine                  ;

                ld de,$0000                     ;
eX4             equ .-2                         ;
                ld hl,$0000                     ;
eX2             equ .-2                         ;
                ld bc,$0000                     ;
eY4             equ .-2                         ;

                call HoriLineEx                 ;

                call c,AddLine                  ;

                ld hl,(eX2)                     ;
                ld de,(eX4)                     ;
                ld bc,$0000                     ;
eY3             equ .-2                         ;

                call HoriLineEx                 ;

                call c,AddLine                  ;

                ld hl,(eX4)                     ;
                ld de,(eX3)                     ;
                ld bc,$0000                     ;
eY2             equ .-2                         ;

                call HoriLineEx                 ;

                call c,AddLine                  ;

                ld hl,(eX4)                     ;
                ld de,(eX3)                     ;
                ld bc,$0000                     ;
eY1             equ .-2                         ;

                jp HoriLineEx                   ;

ObjeNotShown    call UndrawLines                ;

                call AddFirstLine               ;

                ret                             ;

DispMiss        ld a,(ix+dObjeCol)              ;

                inc a                           ;
                and $03                         ;
                or $44                          ;
                ld (ix+dObjeCol),a              ;

                ld hl,(ix+dObjeY)               ;
                ld de,(GroundY)                 ;
                or a                            ;
                sbc hl,de                       ;
                or a                            ;
                bit 7,h                         ;
                jp z,KillObject                 ;

                ld de,(ix+dObjeZ)               ;
                ld (TempZ),de                   ;

                ld hl,(ix+dObjeX)               ;
                call ObjeDiv                    ;
                ld (X1),hl                      ;

                ld bc,128                       ;
                add hl,bc                       ;
                ld a,h                          ;
                add a,2                         ;
                cp 4                            ;
                jp nc,ObjeNotShown              ;

                ld hl,(ix+dObjeY)               ;
                ld de,(TempZ)                   ;
                call ObjeDiv                    ;
                ld (Y1),hl                      ;

                ld bc,128                       ;
                add hl,bc                       ;
                ld a,h                          ;
                add a,2                         ;
                cp 4                            ;
                jp nc,ObjeNotShown              ;

ShowMiss        ld hl,(TempZ)                   ;
                sra h                           ;
                rr l                            ;
                sra h                           ;
                rr l                            ;
                sra h                           ;
                rr l                            ;
                ld (TempZ),hl                   ;

                dec (ix+dObjeCnt)               ;
                ld a,(ix+dObjeCnt)              ;
                and $03                         ;

                jp z,Miss1                      ;

                dec a                           ;
                jp z,Miss2                      ;

                dec a                           ;
                jp z,Miss3                      ;

Miss4           ld hl,0                         ;
                exx                             ;
                ld hl,$28                       ;
                jp Miss0                        ;

Miss3           ld hl,$10                       ;
                exx                             ;
                ld hl,$24                       ;
                jp Miss0                        ;

Miss2           ld hl,$20                       ;
                exx                             ;
                ld hl,$20                       ;
                jp Miss0                        ;

Miss1           ld hl,$24                       ;
                exx                             ;
                ld hl,$10                       ;

Miss0           ld de,(TempZ)                   ;
                call ObjeDiv                    ;

                ex de,hl                        ;
                exx                             ;

                ld de,(TempZ)                   ;
                call ObjeDiv                    ;

                ex de,hl                        ;

                ld hl,(X1)                      ;
                add hl,de                       ;
                ld (mXa),hl                     ;

                or a                            ;
                sbc hl,de                       ;
                or a                            ;
                sbc hl,de                       ;

                ld (mXc),hl                     ;

                ld hl,(Y1)                      ;
                add hl,de                       ;
                ld (mYd),hl                     ;

                or a                            ;
                sbc hl,de                       ;
                or a                            ;
                sbc hl,de                       ;

                ld (mYb),hl                     ;

                exx                             ;

                ld hl,(X1)                      ;
                add hl,de                       ;
                ld (mXd),hl                     ;

                or a                            ;
                sbc hl,de                       ;
                or a                            ;
                sbc hl,de                       ;

                ld (mXb),hl                     ;

                ld hl,(Y1)                      ;
                add hl,de                       ;
                ld (mYc),hl                     ;

                or a                            ;
                sbc hl,de                       ;
                or a                            ;
                sbc hl,de                       ;

                ld (mYa),hl                     ;

                call UndrawLines                ;

                call AddFirstLine               ;
                ret c                           ;

                ld hl,$0000                     ;
mYa             equ .-2                         ;
                ld de,$0000                     ;
mYc             equ .-2                         ;
                exx                             ;
                ld hl,$0000                     ;
mXa             equ .-2                         ;
                ld de,$0000                     ;
mXc             equ .-2                         ;

                call AnyLine                    ;

                call c,AddLine                  ;

                ld a,(Colour)                   ;
                xor $03                         ;
                ld (Colour),a                   ;

                ld hl,$0000                     ;
mYb             equ .-2                         ;
                ld de,$0000                     ;
mYd             equ .-2                         ;
                exx                             ;
                ld hl,$0000                     ;
mXb             equ .-2                         ;
                ld de,$0000                     ;
mXd             equ .-2                         ;

                call AnyLine                    ;

                bit bOnScreen,(ix+dObjeFlags)   ;
                jp z,KillObject                 ;

                ret                             ;

DispSAM         dec (ix+dObjeCntA)              ;
                jp z,DispSAMns                  ;

                ld a,(ix+dObjeCntiB)            ;
                cp 1                            ;
                jr z,DispSAM1                   ;

                ld de,(ix+dObjeBdYS)            ;
                ld hl,(ix+dObjeY)               ;
                add hl,de                       ;
                ld (ix+dObjeY),hl               ;

DispSAM1        ld hl,(ix+dObjeX)               ;
                ld de,(ix+dObjeZ)               ;
                ld (TempZ),de                   ;

                call ObjeDiv                    ;

                ld a,h                          ;
                add a,2                         ;
                cp 4                            ;
                jp nc,ObjeNotShown              ;

                ld (X1),hl                      ;

                ld hl,(ix+dObjeY)               ;
                ld de,(TempZ)                   ;
                call ObjeDiv                    ;
                ld (Y1),hl                      ;

                ld hl,(GroundY)                 ;
                ld de,(TempZ)                   ;
                call ObjeDiv                    ;
                ld (Y2),hl                      ;

                bit 0,(ix+dObjeStateF)          ;
                jr nz,SAMRising                 ;

                ld a,(ix+dObjeCntiB)            ;
                or a                            ;
                jr nz,SAMretreat                ;

                call ShowMiss                   ;

                res bKilled,(ix+dObjeFlags)     ;

                call AddLine                    ;

SAMa            ld hl,(Y1)                      ;
                ld de,(Y2)                      ;
                ld bc,(X1)                      ;

                jp VertLine                     ;

SAMretreat      call UndrawLines                ;

                call AddFirstLine               ;
                ret c                           ;

                jp SAMa                         ;

SAMRising       ld a,(ix+dObjeCntiB)            ;
                or a                            ;
                jr nz,SAMRisingret              ;

                call ShowMiss                   ;
                res bKilled,(ix+dObjeFlags)     ;

                call AddLine                    ;

SAMRisingA      ld de,(Y1)                      ;
                ld hl,(Y2)                      ;
                or a                            ;
                sbc hl,de                       ;

                sra h                           ;
                rr l                            ;

                ex de,hl                        ;

                ld hl,(X1)                      ;
                or a                            ;
                sbc hl,de                       ;
                push hl                         ;

                add hl,de                       ;
                add hl,de                       ;

                pop de                          ;
                ex de,hl                        ;
                ld bc,(Y2)                      ;

                jp HoriLine                     ;

SAMRisingret    call UndrawLines                ;

                call AddFirstLine               ;
                ret c                           ;

                jp SAMRisingA                   ;

DispSAMns       ld a,(ix+dObjeCntiB)            ;
                cp 2                            ;
                jp z,KillObject                 ;

                cp 1                            ;
                jr z,FireMiss                   ;

                inc (ix+dObjeCntiB)             ;

FireMiss        ld a,r                          ;
                and $07                         ;
                add a,4                         ;
                ld (ix+dObjeCntA),a             ;

                call FireMissile                ;

                dec (ix+dObjeCntB)              ;
                ret nz                          ;

DispSAMexit     ld (ix+dObjeCntiB),2            ;
                ld a,(ix+dObjeCntiA)            ;
                ld (ix+dObjeCntA),a             ;

                ld hl,(ix+dObjeBdYS)            ;
                Neg_HL()                        ;
                ld (ix+dObjeBdYS),hl            ;

                ret                             ;

FireMissile     ld hl,(ix+dObjeZ)               ;
                ld de,(ix+dObjeX)               ;
                ld bc,(ix+dObjeY)               ;

                exx                             ;
                ld hl,0                         ;
                ld de,0                         ;
                ld bc,0                         ;
                exx                             ;

                push ix                         ;

                ld a,(ix+dObjeWeapon)           ;
                call CreateObject               ;

                pop ix                          ;

                ret                             ;

DispSquareB     call CalcSquareB34              ;

                ld hl,(X4)                      ;
                ld (ix+dObjeDispXL),hl          ;

                ld hl,(X3)                      ;
                ld (ix+dObjeDispXR),hl          ;

                ld hl,(Y4)                      ;
                ld (ix+dObjeDispYT),hl          ;

                ld hl,(Y3)                      ;
                ld (ix+dObjeDispYB),hl          ;

                jr DispSq1                      ;

DispSquare      call CalcSquareA34              ;

DispSq1         call UndrawLines                ;

                call AddFirstLine               ;
                ret c                           ;

                ld hl,(X4)                      ;
                ld de,(X3)                      ;
                ld bc,(Y3)                      ;

                call HoriLine                   ;

                call c,AddLine                  ;

                ld hl,(X4)                      ;
                ld de,(X3)                      ;
                ld bc,(Y4)                      ;

                call HoriLine                   ;

                call c,AddLine                  ;

                ld hl,(Y4)                      ;
                ld de,(Y3)                      ;
                ld bc,(X3)                      ;

                call VertLine                   ;

                call c,AddLine                  ;

                ld hl,(Y4)                      ;
                ld de,(Y3)                      ;
                ld bc,(X4)                      ;

                jp VertLine                     ;

DispIris        call CalcSquareB12              ;

                call DispSquare                 ;

                call c,AddLine                  ;

                ld hl,(X2)                      ;
                ld de,(X3)                      ;
                ld bc,(Y1)                      ;

                call HoriLine                   ;

                call c,AddLine                  ;

                ld hl,(X4)                      ;
                ld de,(X1)                      ;
                ld bc,(Y2)                      ;

                call HoriLine                   ;

                call c,AddLine                  ;

                ld hl,(Y2)                      ;
                ld de,(Y3)                      ;
                ld bc,(X2)                      ;

                call VertLine                   ;

                call c,AddLine                  ;

                ld hl,(Y4)                      ;
                ld de,(Y1)                      ;
                ld bc,(X1)                      ;

                call VertLine                   ;

                jp AlterWindow1                 ;

DispIrisA       call DispParaH                  ;

                jp AlterWindow1                 ;

DispIrisB       call CalcSquareB12              ;

                call DispSquare                 ;

                jp AlterWindow1                 ;

DispIrisC       call CalcSquareB12              ;

                jp AlterWindow1                 ;

DispParaH       call CalcSquareB12              ;

                call CalcSquareA34              ;

                call UndrawLines                ;

                call AddFirstLine               ;
                ret c                           ;

                ld hl,(X2)                      ;
                ld de,(X1)                      ;
                ld bc,(Y1)                      ;

                call HoriLine                   ;

                call c,AddLine                  ;

                ld hl,(X2)                      ;
                ld de,(X1)                      ;
                ld bc,(Y2)                      ;

                call HoriLine                   ;

                call c,AddLine                  ;

                ld hl,(X4)                      ;
                ld de,(X3)                      ;
                ld bc,(Y3)                      ;

                call HoriLine                   ;

                call c,AddLine                  ;

                ld hl,(X4)                      ;
                ld de,(X3)                      ;
                ld bc,(Y4)                      ;

                jp HoriLine                     ;

DispForce       call CalcSquareB12              ;

                ld hl,(ix+dObjeFFH1)            ;
                ld de,0                         ;
                ld (ix+dObjeFFH1),de            ;

                call Undrawlp                   ;

                call FFgetline                  ;
                ret c                           ;

                ld hl,(X2)                      ;
                ld de,(X1)                      ;
                ld bc,(Y1)                      ;

                call HoriLine                   ;

                push iy                         ;
                pop hl                          ;

                ld (ix+dObjeFFH1),hl            ;

                ld hl,(ix+dObjeFFH2)            ;
                ld de,0                         ;

                call Undrawlp                   ;

                call FFgetline                  ;
                ret c                           ;

                ld hl,(X2)                      ;
                ld de,(X1)                      ;
                ld bc,(Y2)                      ;

                call HoriLine                   ;

                push iy                         ;
                pop hl                          ;

                ld (ix+dObjeFFH2),hl            ;

                ld hl,(ix+dObjeFFV1)            ;
                ld de,0                         ;
                ld (ix+dObjeFFV1),de            ;

                call Undrawlp                   ;

                call FFgetline                  ;
                ret c                           ;

                ld hl,(Y2)                      ;
                ld de,(Y1)                      ;
                ld bc,(X1)                      ;

                call VertLine                   ;

                push iy                         ;
                pop hl                          ;

                ld (ix+dObjeFFV1),hl            ;

                ld hl,(ix+dObjeFFV2)            ;
                ld de,0                         ;
                ld (ix+dObjeFFV2),de            ;

                call Undrawlp                   ;

                call FFgetline                  ;
                ret c                           ;

                ld hl,(Y2)                      ;
                ld de,(Y1)                      ;
                ld bc,(X2)                      ;

                call VertLine                   ;

                push iy                         ;
                pop hl                          ;

                ld (ix+dObjeFFV2),hl            ;

AlterWindow1    bit 6,(ix+dObjeStateF)          ;
                ret nz                          ;

                ld hl,(X2)                      ;
                ld (ix+dObjeDispXL),hl          ;

                ld hl,(X1)                      ;
                ld (ix+dObjeDispXR),hl          ;

                ld hl,(Y2)                      ;
                ld (ix+dObjeDispYT),hl          ;

                ld hl,(Y1)                      ;
                ld (ix+dObjeDispYB),hl          ;

AlterWindow     ld iy,(pcWindow)                ;

                ld hl,(ix+dObjeZ)               ;
                ld (iy+dWindZ),hl               ;

                ld hl,(X2)                      ;
                inc hl                          ;
                ld (iy+dWindL),hl               ;
                call SetLMargin                 ;

                ld hl,(X1)                      ;
                dec hl                          ;
                ld (iy+dWindR),hl               ;
                call SetRMargin                 ;

                ld hl,(Y2)                      ;
                inc hl                          ;
                ld (iy+dWindU),hl               ;
                call SetUMargin                 ;

                ld hl,(Y1)                      ;
                dec hl                          ;
                ld (iy+dWindD),hl               ;
                call SetDMargin                 ;

                ld bc,lWind                     ;
                add iy,bc                       ;
                ld hl,$7FFF                     ;
                ld (iy+dWindZ),hl               ;

                ld (pcWindow),iy                ;

                ld a,$07                        ;
                ld (WindowMask),a               ;

                ret                             ;

AlterRHS        push hl                         ;

                ld hl,(pcWindow)                ;
                ld d,h                          ;
                ld e,l                          ;

                push hl                         ;
                pop iy                          ;

                ld bc,lWind                     ;
                or a                            ;
                sbc hl,bc                       ;

                ldir                            ;

                ld (pcWindow),de                ;

                pop hl                          ;
                dec hl                          ;

                ld (iy+dWindR),hl               ;
                call SetRMargin                 ;

                ld hl,(ix+dObjeZ)               ;
                ld (iy+dWindZ),hl               ;
                ld hl,$7FFF                     ;
                ld (iy+11),l                    ;
                ld (iy+12),h                    ;

                ret                             ;

DoSizeCycle     dec (ix+dObjeCnt)               ;
                jr z,NextCycle                  ;

                ld hl,(ix+dObjeBdXS)            ;
                ld de,(ix+dObjeBXS)             ;
                add hl,de                       ;
                ld (ix+dObjeBXS),hl             ;

                ld hl,(ix+dObjeBdYS)            ;
                ld de,(ix+dObjeBYS)             ;
                add hl,de                       ;
                ld (ix+dObjeBYS),hl            ;

                ret                             ;

NextCycle       ld hl,dObjepSizeTab             ;

                push ix                         ;
                pop de                          ;
                add hl,de                       ;

                ld e,(hl)                       ;
                inc hl                          ;
                ld d,(hl)                       ;
                inc hl                          ;

                ex de,hl                        ;

                ld a,(hl)                       ;
                or a                            ;
                jr z,NCloop                     ;

NCa             ld bc,5                         ;
                ldir                            ;

                ld (ix+dObjepSizeTab),hl        ;

                ret                             ;

NCloop          inc hl                          ;
                ld a,(hl)                       ;
                inc hl                          ;
                ld h,(hl)                       ;
                ld l,a                          ;

                jp NCa                          ;

X1              defs 2                          ;
X2              defs 2                          ;
Y1              defs 2                          ;
Y2              defs 2                          ;

X3              defs 2                          ;
X4              defs 2                          ;
Y3              defs 2                          ;
Y4              defs 2                          ;

X5              defs 2                          ;
X6              defs 2                          ;
Y5              defs 2                          ;
Y6              defs 2                          ;

TempX           defs 2                          ;
TempY           defs 2                          ;
TempZ           defs 2                          ;

; End of DRAW
