; The main game code

                org $9400

GameCode        call Options_Subs               ;

                call SetUpTabs                  ;

                call GenYTab                    ;

                call Gen192Tab                  ;

                call InitVars                   ;

                call InitStars                  ;

                call InitObjes                  ;

                call InitLines                  ;

                call CreateStars                ;

                call InitCodes                  ;

                call InitStats                  ;

                ld a,$47                        ;
                ld (GameAttr),a                 ;
                ld (Colour),a                   ;

                ld a,DamFSD                     ;
                ld (DDamage),a                  ;

                ld a,GameRunning                ;
                ld (EndState),a                 ;

                call CLS                        ;

                ld hl,$1000                     ;
                ld (Distance),hl                ;

                halt                            ;
                halt                            ;

                ld a,(Mode)                     ;
                cp ModeDemo                     ;
                jp z,DoDemo                     ;

                call InitMap                    ;

        if enabled bFrameLock

Loop            ld a,(cSecCount)                ; Wait until this one ends
                ld b,a                          ;

FrameLock       ld a,(SecCount)                 ;
                cp b                            ;
                jr z FrameLock                  ;

                ld (cSecCount),a                ; Save it
        else
Loop            equ *
        endif

                ; Draw a frame

                ld a,(ADamage)                  ;
                or a                            ;
                jr z,Exit                       ;

                ld a,(EndState)                 ;
                cp GameRunning                  ;
                jr nz,Exit                      ;

                call AlterSteps                 ;

                call DoVectors                  ;

                call DrawSights                 ;

                call ShowObje                   ;

                call ShowStars                  ;

                call PlayerFire                 ;

                call AddObjects                 ;

                ; Now, frame lock it here?

                ld bc,$EFFE                     ;
                in a,(c)                        ;
                or $E0                          ; 6,7,8,9,0
                inc a                           ;
                jp nz,Loop                      ;

                ld bc,$F7FE                     ;
                in a,(c)                        ;
                bit 3,a                         ;
                jr z,Loop                       ;

                or $F8                          ; 1,2,3
                inc a                           ;
                jp z,Loop                       ;

                call DispStats                  ;

                jp Loop                         ;

Exit            di                              ;

                ld bc,0                         ;

ExitLp          cpi                             ;
                jp pe,ExitLp                    ;

                ret                             ;

